package net.wanji.common.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * 场景代码与协调方向映射关系
 *
 * @author Kent HAN
 * @date 2022/11/8 17:20
 */
@Getter
@AllArgsConstructor
public enum SceneDirEnum {
    ONE(5, 0),
    TWO(5, 1),
    THREE(6, 2);

    private final int sceneNum;
    private final int dir;

    public static Integer getSceneNumByDir(int dir) {
        for (SceneDirEnum value : SceneDirEnum.values()) {
            if (value.dir == dir) {
                return value.sceneNum;
            }
        }
        return null;
    }
}
