package net.wanji.common.tool.redistool;


import redis.clients.jedis.Jedis;
import redis.clients.jedis.JedisPool;
import redis.clients.jedis.JedisPoolConfig;

public class RedisUtil {
    public static JedisPool jedisPool=null;
    public static Jedis getInstance(String server,int port,int database,String password) {
        JedisPoolConfig jedisPoolConfig = new JedisPoolConfig();
        jedisPoolConfig.setMaxTotal(100); //最大可用连接数
        jedisPoolConfig.setBlockWhenExhausted(true); //连接耗尽后是否等待
        jedisPoolConfig.setMaxWaitMillis(2000); //等待时间
        jedisPoolConfig.setMaxIdle(5); //最大闲置连接数
        jedisPoolConfig.setMinIdle(5); //最小闲置连接数
        jedisPoolConfig.setTestOnBorrow(true); //连接的时候测试一下ping pong
        jedisPool = new JedisPool(jedisPoolConfig, server, port, 1000, password, database);
        System.out.println("开辟连接池");
        return jedisPool.getResource();
    }

    public static boolean checkConn(){
        if(jedisPool!=null&&jedisPool.getResource().isConnected()){
            jedisPool.close();
            return true;
        }
        return false;
    }

    public static void main(String []args){
        RedisUtil.getInstance("10.102.1.182",6379,7,"Wanji300552");
        System.out.println(RedisUtil.checkConn());
    }
}
