package net.wanji.common.utils.tool;

import java.util.List;

/**
 * @author Kent HAN
 * @date 2022/11/9 16:48
 */
public class CrossUtil {
    // 从路口信息中分离经纬度
    public static double[] getLonLat(String location) {
        List<String> result = RegexUtils.getMatchGroups(location,
                "^POINT\\(([0-9]*\\.?[0-9]+) ([0-9]*\\.?[0-9]+)\\)$", 2);
        String longitudeStr = result.get(1);
        double longitude = Double.parseDouble(longitudeStr);
        String latitudeStr = result.get(2);
        double latitude = Double.parseDouble(latitudeStr);
        double[] lonLat = {longitude, latitude};
        return lonLat;
    }

    public static String getServiceLevel(Double sturation) {
        String res = "";
        if (sturation < 0.4) {
            res = "A";
        } else if (sturation < 0.6) {
            res = "B";
        } else if (sturation < 0.75) {
            res = "C";
        } else if (sturation < 0.9) {
            res = "D";
        } else if (sturation < 1.0) {
            res = "E";
        } else {
            res = "F";
        }
        return res;
    }

    public static int calcEfficiencyLevel(Integer delayTime, Double queueLength) {
        int level = 0;
        if (delayTime != null) {
            if (delayTime >=40 && delayTime <= 49) {
                level = 3;
            } else if (delayTime >= 50) {
                level = 4;
            }
        }
        if (queueLength != null) {
            int intQueueLength = (int) Math.round(queueLength);
            if (intQueueLength >= 60 && intQueueLength <=79 && level < 3) {
                level = 3;
            } else if (intQueueLength >= 80) {
                level = 4;
            }
        }
        return level;
    }
}
